# ----------------------------------------------------------------------
#
# Plot a VTK mesh using Paraview and directly render a nice view for
# plotting and saving figure.
#
# This script should be run in Paraview Python Shell window.
#
# Francois Lavoue, 10 March 2019
# Last updated FL, 19 July 2019
#
# ----------------------------------------------------------------------
#
# Notes:
#
# This script takes a VTK file generated by SEM46 as input, unlike its
# companion 22*.py that takes a VTS file generated by the seiscope_pytools
# .io.writes.gllparam2vts and fortrantable2vts functions.
#
# These VTK and VTS files seem to adopt different z-axis conventions
# (up- vs. downward-pointing), which makes rendering the two with the
# exact same view not obvious (see view.Camera* settings below).
#
# Initial trace generated using paraview version 5.6.0. This script is
# therefore not very clean nor concise, but it does the job as it is.
# Commands also inspired from Exercises 3.8 to 3.12 in Paraview Tutorial.
#
# To ensure correct image size when batch processing, search for and
# uncomment the line `# renderView*.ViewSize = [*,*]` .
#
# ----------------------------------------------------------------------


#### import the simple module from the paraview
from paraview.simple import *

## Init: Reset session and disable automatic camera reset on 'Show'
ResetSession()
paraview.simple._DisableFirstRenderCameraReset()


#-- user parameters

# working dir (must be an absolute path)
dir0 = '/Users/lavouef/git/PACIFIC/codes/design_and_run_sem46_simulations_in_synthetic_models.clean'

dir_in = dir0 + '/results/output_run_simulation_in_simple_synthetic_model_v8a_2-horizontal-layers'

# input file
file_in = 'mesh'   # 'mesh' for element outline or 'structure' for all GLL points (without .vtk extension)

# plot sources and receivers?
plot_src = True
plot_rec = True

rad_src = 50.   # (m)
rad_rec = 25.

rgb_src = [1.0, 0.0, 0.0]
rgb_rec = [0.0, 1.0, 0.0]

# specify camera placement
view = lambda:0
view.CameraPosition = [-11650., 31395., -13835.]
view.CameraFocalPoint = [2500., 1000.0, 3357.]
view.CameraViewUp = [-0.1017, -0.5252, -0.8449]
view.CameraParallelScale = 11800.

# NB: this is case-dependent and you may not know the suitable values at first.
#     You may then leave the structure empty ("view = lambda:0") and change it
#     in a second time for another view obtained manually by typing the
#     following in the Paraview Python shell:
# view = GetActiveView()
# print(view.CameraPosition)
# print(view....)

#-- end user parameters


# create a new 'Legacy VTK Reader' for mesh
meshvtk = LegacyVTKReader( FileNames= dir_in + '/vtk_files/' + file_in + '.vtk' )

# create a new 'Legacy VTK Reader' for source and receivers
if plot_src :
   srcvtk = LegacyVTKReader( FileNames = dir_in + '/vtk_files/src.vtk' )
if plot_rec :
   recvtk = LegacyVTKReader( FileNames = dir_in + '/vtk_files/rec.vtk' )

# set active source
SetActiveSource(meshvtk)

# get active view
renderView1 = GetActiveViewOrCreate('RenderView')
# uncomment following to set a specific view size
# renderView1.ViewSize = [1260, 961]

# show data in view
meshvtkDisplay = Show(meshvtk, renderView1)

# trace defaults for the display properties.
meshvtkDisplay.Representation = 'Surface With Edges'
meshvtkDisplay.ColorArrayName = ['POINTS', '']
meshvtkDisplay.OSPRayScaleArray = 'scalar'
meshvtkDisplay.OSPRayScaleFunction = 'PiecewiseFunction'
meshvtkDisplay.SelectOrientationVectors = 'None'
meshvtkDisplay.ScaleFactor = 747.8626541137696
meshvtkDisplay.SelectScaleArray = 'scalar'
meshvtkDisplay.GlyphType = 'Sphere'
meshvtkDisplay.GlyphTableIndexArray = 'scalar'
meshvtkDisplay.GaussianRadius = 37.39313270568848
meshvtkDisplay.SetScaleArray = ['POINTS', 'scalar']
meshvtkDisplay.ScaleTransferFunction = 'PiecewiseFunction'
meshvtkDisplay.OpacityArray = ['POINTS', 'scalar']
meshvtkDisplay.OpacityTransferFunction = 'PiecewiseFunction'
meshvtkDisplay.DataAxesGrid = 'GridAxesRepresentation'
meshvtkDisplay.SelectionCellLabelFontFile = ''
meshvtkDisplay.SelectionPointLabelFontFile = ''
meshvtkDisplay.PolarAxes = 'PolarAxesRepresentation'
meshvtkDisplay.ScalarOpacityUnitDistance = 105.12769932593838

# init the 'GridAxesRepresentation' selected for 'DataAxesGrid'
meshvtkDisplay.DataAxesGrid.XTitleFontFile = ''
meshvtkDisplay.DataAxesGrid.YTitleFontFile = ''
meshvtkDisplay.DataAxesGrid.ZTitleFontFile = ''
meshvtkDisplay.DataAxesGrid.XLabelFontFile = ''
meshvtkDisplay.DataAxesGrid.YLabelFontFile = ''
meshvtkDisplay.DataAxesGrid.ZLabelFontFile = ''

# init the 'PolarAxesRepresentation' selected for 'PolarAxes'
meshvtkDisplay.PolarAxes.PolarAxisTitleFontFile = ''
meshvtkDisplay.PolarAxes.PolarAxisLabelFontFile = ''
meshvtkDisplay.PolarAxes.LastRadialAxisTextFontFile = ''
meshvtkDisplay.PolarAxes.SecondaryRadialAxesTextFontFile = ''

# reset view to fit data
renderView1.ResetCamera()

#-- Change background color to white
renderView1.Background = [ 1.0, 1.0, 1.0 ]
renderView1.OrientationAxesLabelColor = [0., 0., 0.]
Render()

#-- Make axis visible and change axis and label color to black
meshvtkDisplay.DataAxesGrid.GridAxesVisibility = 1

# Properties modified on Display.DataAxesGrid
meshvtkDisplay.DataAxesGrid.XTitleColor = [0.0, 0.0, 0.0]
meshvtkDisplay.DataAxesGrid.YTitleColor = [0.0, 0.0, 0.0]
meshvtkDisplay.DataAxesGrid.ZTitleColor = [0.0, 0.0, 0.0]
meshvtkDisplay.DataAxesGrid.XLabelColor = [0.0, 0.0, 0.0]
meshvtkDisplay.DataAxesGrid.YLabelColor = [0.0, 0.0, 0.0]
meshvtkDisplay.DataAxesGrid.ZLabelColor = [0.0, 0.0, 0.0]

# Properties modified on meshvtkDisplay.DataAxesGrid
meshvtkDisplay.DataAxesGrid.XTitle = 'X (m)'
meshvtkDisplay.DataAxesGrid.YTitle = 'Y (m)'
meshvtkDisplay.DataAxesGrid.ZTitle = 'Z (m)'

#-- Show sources and receivers
if plot_src :
   SetActiveSource(srcvtk)
   srcvtkDisplay = Show(srcvtk, renderView1)
   srcvtkDisplay.SetRepresentationType('Point Gaussian')
   srcvtkDisplay.GaussianRadius = rad_src

   # change solid color of src
   srcvtkDisplay.DiffuseColor = rgb_src

if plot_rec :
   SetActiveSource(recvtk)
   recvtkDisplay = Show(recvtk, renderView1)
   recvtkDisplay.SetRepresentationType('Point Gaussian')
   recvtkDisplay.GaussianRadius = rad_rec

   # change solid color of rec
   recvtkDisplay.DiffuseColor = rgb_rec

# update the view to ensure updated data information
renderView1.Update()

# reset view to fit data
renderView1.ResetCamera()

#### saving camera placements for all active views

# change camera placement for renderView1 (if specified in user parameters)
try :
   renderView1.CameraPosition = view.CameraPosition
   renderView1.CameraFocalPoint = view.CameraFocalPoint
   renderView1.CameraViewUp = view.CameraViewUp
   renderView1.CameraParallelScale = view.CameraParallelScale
except :
   print()

#-- Save figure
SaveScreenshot( dir_in + '/figs/' + file_in + '.png' )

#### uncomment the following to render all views
# RenderAllViews()
# alternatively, if you want to write images, you can use SaveScreenshot(...).

